Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 233097 - ebuild for openwatcom
Summary: ebuild for openwatcom
Status: CONFIRMED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: [OLD] Development (show other bugs)
Hardware: All Linux
: High enhancement with 1 vote (vote)
Assignee: Default Assignee for New Packages
URL: http://www.openwatcom.org/index.php/L...
Whiteboard:
Keywords: EBUILD
Depends on:
Blocks:
 
Reported: 2008-07-27 10:42 UTC by Thomas Nichols
Modified: 2019-12-11 17:12 UTC (History)
7 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
Open Watcom ebuild created by Dron (openwatcom-1.7.1-r1.ebuild,753 bytes, text/plain)
2008-07-27 12:29 UTC, Vladimir Sadovnikov
Details
Sybase Open Watcom Public License version 1.0 (OWPL-1,20.29 KB, text/plain)
2008-07-28 19:28 UTC, Andrey Valyaev
Details
OpenWatcom 1.7.1 ebuild (openwatcom-1.7.1.ebuild,694 bytes, text/plain)
2008-07-28 19:37 UTC, Andrey Valyaev
Details
Openwatcom 1.7.1 and 1.8.0 ebuilds (openwatcom.tgz,1.64 KB, text/plain)
2009-10-07 10:08 UTC, Piotr Trojanek
Details
Recognize AMD64 as acceptable architecture (wmake_c_mglob.c.patch,480 bytes, patch)
2009-10-10 12:34 UTC, David Relson
Details | Diff
openwatcom-1.9.0.ebuild (openwatcom-1.9.0.ebuild,988 bytes, text/plain)
2012-03-14 08:51 UTC, Anton Kochkov
Details
full build log (openwatcom_build.log,545.80 KB, text/plain)
2012-06-14 05:57 UTC, Anton Kochkov
Details
openwatcom live ebuild (openwatcom-9999.ebuild,898 bytes, text/plain)
2012-08-20 20:28 UTC, Anton Kochkov
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Thomas Nichols 2008-07-27 10:42:15 UTC
The OpenWatcom C++ compiler at www.openwatcom.org has a work-in-progress Linux port but there is no ebuild for it. Having an ebuild could encourage more Gentoo involvement in that port. An ebuild is currently being worked on - see http://www.openwatcom.org/index.php/Installing_Open_Watcom_on_Linux and http://www.openwatcom.org/index.php/User:SadKo

Reproducible: Always
Comment 1 Vladimir Sadovnikov 2008-07-27 12:29:41 UTC
Created attachment 161462 [details]
Open Watcom ebuild created by Dron
Comment 2 Vladimir Sadovnikov 2008-07-27 12:31:07 UTC
Thanks to Andrey 'Dron' Valyaev (http://mdf-i.blogspot.com/) for creating alternative gentoo open watcom ebuild.
Comment 3 Carsten Lohrke (RETIRED) gentoo-dev 2008-07-27 14:01:42 UTC
- you inherit eclesses, which are never used
- use examples, not samples, source not sources
- Do not create $P in src_unpack(), set $S 
- $D needs to be quoted
- Missing the license test file attached
Comment 4 Andrey Valyaev 2008-07-28 19:28:41 UTC
Created attachment 161568 [details]
Sybase Open Watcom Public License version 1.0
Comment 5 Andrey Valyaev 2008-07-28 19:37:14 UTC
Created attachment 161574 [details]
OpenWatcom 1.7.1 ebuild

This ebuild is okay?
Comment 6 Thomas Nichols 2008-07-29 10:50:52 UTC
(In reply to comment #4)
> Created an attachment (id=161568) [edit]
> Sybase Open Watcom Public License version 1.0
> 


License is OSI-approved -
http://www.opensource.org/licenses/sybase.php
Comment 7 Thomas Nichols 2008-07-29 14:21:08 UTC
-- build report --

ebuild from 2008-07-28T19:37 works for me.

I created overlay dir `/usr/local/portage/custom/sys-devel/openwatcom` and used `ebuild openwatcom-1.7.1.ebuild` as per
http://gentoo-wiki.com/HOWTO_Installing_3rd_Party_Ebuilds - just needed to `ebuild openwatcom-1.7.1.ebuild digest` and emerge.

Keywords are set to 'x86' so no unmasking/keywording required for me.

export WATCOM=/opt/openwatcom

export INCLUDE=$WATCOM/lh

and I can successfully `owcc hello.c` and `./a.out`

-- warning: wildly off-topic for this bug report --

The PDF at http://www.scitechsoft.com/pdf/openwatcom_crossbebug_QNX_whitepaper.pdf (Sep 2006 - needs registration) suggests the debugger will handle gcc-built apps: "Open Watcom Debugger is already functional for debugging GNU gcc generated code for x86 Linux targets. The remote debugger can run natively on Linux host with either a text-based window for console modes or an X client window for GUI desktop modes."

Compiling with `owcc -g2 hello.c` and then `wd a.out` gives me a fabulous ncurses debugger that looks just like it did back in '95 on DOS32 :-) This just might be a viable toolchain.

FWIW, Debian seem to have decided the licensing is not sufficiently Free for them: 
http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=376431

Can't find any benchmarks comparing OW with GCC on Linux, though. Anyone?
Comment 8 Vladimir Sadovnikov 2008-08-29 20:01:59 UTC
Is openwatcom-1.7.1.ebuild a final release?
Can I take it to make an OpenWatcom mirror?
Comment 9 Albert Zeyer 2009-01-12 18:23:33 UTC
openwatcom-1.7.1.ebuild emerges fine for me and openwatcom works fine.
Comment 10 Piotr Trojanek 2009-10-07 10:08:33 UTC
Created attachment 206293 [details]
Openwatcom 1.7.1 and 1.8.0 ebuilds
Comment 11 David Relson 2009-10-10 12:34:11 UTC
Created attachment 206649 [details, diff]
Recognize AMD64 as acceptable architecture

Recognize X86_64 in addition to 386 to orrect "Unknown CPU architecture" error in wmake/c/mglob.c
Comment 12 David Relson 2009-10-10 12:37:17 UTC
I'm trying to build openwatcom-1.8.0 on an AMD64 and have encountered 2 problems. 

#1 - "Unknown CPU architecture" error in wmake/c/mglob.c.  I've submitted a patch for the problem.

#2 - wlink segfaults, which kills the build (see below).  Will post more info when I have it.

wlink op q format dos com op nodefault file code386.obj name xcode386.tmp disable 1023,1080
Segmentation fault
Error(E42): Last command making (xcode386.tmp) returned a bad status
Error(E02): Make execution terminated
Comment 13 John Bowler 2010-07-24 18:47:06 UTC
The openwatcom-1.8.0 ebuild has a QA notice because of writeable and executable .sym files:

 * QA Notice: The following files contain writable and executable sections
 *  Files with such sections will not work properly (or at all!) on some
 *  architectures/operating systems.  A bug should be filed at
 *  http://bugs.gentoo.org/ to make sure the issue is fixed.
 *  For more information, see http://hardened.gentoo.org/gnu-stack.xml
 *  Please include the following list of files in your report:
 *  Note: Bugs should be filed for the respective maintainers
 *  of the package in question and not hardened@g.o.
 * !WX --- --- opt/openwatcom/binl/codeview.sym
 * !WX --- --- opt/openwatcom/binl/dwarf.sym

etc.
Comment 14 Anton Kochkov 2012-03-14 08:51:48 UTC
Created attachment 305281 [details]
openwatcom-1.9.0.ebuild

tested on Hardened Gentoo x86 

emerge --info : https://bugs.gentoo.org/attachment.cgi?id=304777
Comment 15 Anton Kochkov 2012-06-14 05:57:15 UTC
Created attachment 315245 [details]
full build log

Looks like 1.9.0 version have trouble with building, log attached
Comment 16 Julian Ospald 2012-06-14 10:24:18 UTC
seems like it overwrites CC and CFLAGS
Comment 17 Anton Kochkov 2012-08-20 20:28:33 UTC
Created attachment 321816 [details]
openwatcom live ebuild

Attaching live ebuild, which builds ok, because all needed fixes pushed to the upstream.
Comment 18 Lars Wendler (Polynomial-C) gentoo-dev 2012-12-27 06:19:22 UTC
app-emulation/virtualbox is using openwatcom now instead of dev86. Time to get this into portage.
Comment 19 Anton Kochkov 2016-05-14 09:02:30 UTC
Since old OpenWatcom seems dead there is a fork of it https://open-watcom.github.io/open-watcom/
It looks very promising and it would be nice to have it in the tree instead of the old one.
See for yourself:


This is V2 Fork of Open Watcom suite of compilers and tools

Bellow is list of main differences against Open Watcom 1.9

    New 2-phase build system, OW can be build by platform native C/C++ compiler or by itself
    Code generator properly initialize pointers by DLL symbol addresses
    DOS version of tools now support long file names (LFN) if appropriate LFN driver is loaded by DOS
    OW is ported to 64-bit hosts (WIN64, Linux X64)
    Librarian support X64 CPU object modules and libraries
    RDOS 32-bit C run-time compact memory model libraries are fixed
    Resource compiler and Resource editors support WIN64 executables
    OW text editor is now self containing, it can be used as standalone tool without any requirements for any additional files or configuration
    Broken C++ compiler pre-compiled header template support is fixed
    Many C++ compiler crashes are fixed
    Debugger has no length limit for any used environment variable
Comment 20 Anton Kochkov 2019-12-11 17:12:10 UTC
(In reply to Anton Kochkov from comment #19)
> Since old OpenWatcom seems dead there is a fork of it
> https://open-watcom.github.io/open-watcom/
> It looks very promising and it would be nice to have it in the tree instead
> of the old one.
> See for yourself:
> 
> 
> This is V2 Fork of Open Watcom suite of compilers and tools
> 
> Bellow is list of main differences against Open Watcom 1.9
> 
>     New 2-phase build system, OW can be build by platform native C/C++
> compiler or by itself
>     Code generator properly initialize pointers by DLL symbol addresses
>     DOS version of tools now support long file names (LFN) if appropriate
> LFN driver is loaded by DOS
>     OW is ported to 64-bit hosts (WIN64, Linux X64)
>     Librarian support X64 CPU object modules and libraries
>     RDOS 32-bit C run-time compact memory model libraries are fixed
>     Resource compiler and Resource editors support WIN64 executables
>     OW text editor is now self containing, it can be used as standalone tool
> without any requirements for any additional files or configuration
>     Broken C++ compiler pre-compiled header template support is fixed
>     Many C++ compiler crashes are fixed
>     Debugger has no length limit for any used environment variable

The project was being actively developed since, and the mainstream bug to track the possible upcoming release is here https://github.com/open-watcom/open-watcom-v2/issues/487